static char *cvs_id =" $Id: xnd_amo.c,v 1.2 2002/01/10 15:24:41 berar Exp $ ";
/* XND_AMO    amorphous phases ... */

#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_ATOM
#define  USE_PENAL
#define  USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"

TYPE_RADIAL *l_radial;
/* ---------------------------------------------------------- */

void int_dist_lambda(P_(void));

/* ---------------------------------------------------------- */
void int_amorphe (P_(void))
{
	int   n;
	int   nd;

	if (minli==0) fprintf(list_fich,"\n");
        nd = l_phase->nb_dist;
	for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
	{  temp = &temp_exper;
	   var_init (l_onde);
		lambda = var_valeur (act->lambda*LAMBDA);
		exper_echelle = var_valeur (act->lambda*LAMBDA+1);
		echelle = phase_echelle * exper_echelle;
      temp = &temp_phase;
		for (n=0, l_radial = l_phase->radial; n<nd; n++,l_radial++)
		    int_dist_lambda();
      }
	}

/* ---------------------------------------------------------- */
float angle ( P_(float) d)
#ifdef NO_PROTO
float d;
#endif
{   float a;
    a = 2/RAD * asin((double) (0.5*lambda/d));
    return a;
   }

/* ---------------------------------------------------------- */
static float ampli;
void amplitude (P_(float) dth)
#ifdef NO_PROTO
float dth;
#endif
{
     sin_t = sin (0.5*RAD*dth);   /* valcor */
     s = 2 * sin_t / lambda;
     cos_t = sqrt (1-sin_t*sin_t);
     valcor ();
     q = s * s;                   /* valdif */
     l_atom = l_radial->at0;
     F_A = valdif();
     l_atom = l_radial->at1;
     F_B = valdif();
     ampli = echelle * act->cor * F_A * F_B;
     }

 /* ---------------------------------------------------------- */
void int_dist_lambda()
{    int   nb_pos;
     float *pos;
     int   i,j,iod;
     int   ip,jp;
     float v1,v2;
     float v,hd,hh;
     float aa,na;
     float z,val;
     float *v1_deriv,*v2_deriv;
     int *p1_deriv,*p2_deriv;
     int   calc_deriv;

     nb_pos=l_radial->nb_pos;
	  fprintf(list_fich," int_dist_lambda    npos %d\n", nb_pos);
     if (nb_pos==0) return;

     temp = &temp_phase;
     var_init(l_radial->distrib);

     for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
     {   
/*         if ( ip % 50 == 0 ) fprintf(list_fich , "amo0 %d  aa %f na %f\n",
             ip, aa, na);     
/*         if ( *l_points <= aa ) continue;   /* pas d'extrapolation */
			amplitude(*l_points);
	      add_ical (ip, ampli);
if ( ip % 50 == 0 ) fprintf(list_fich , " amo %d  %f  %f\n",
      ip, *l_points, ampli);     
	    }
    }
 /* ---------------------------------------------------------- */
/*
void old_int_dist_lambda()
{    int   nb_pos;
     float *pos;
     int   i,j,iod;
     int   ip,jp;
     float v1,v2;
     float v,hd,hh;
     float aa,na;
     float z,val;
     float *v1_deriv,*v2_deriv;
     int *p1_deriv,*p2_deriv;
     int   calc_deriv;

     nb_pos=l_radial->nb_pos;
	 fprintf(list_fich," int_dist_lambda    npos %d\n", nb_pos);
     if (nb_pos==0) return;

     pos = l_radial->diff_pos;
     temp = &temp_phase;
     if (fini==0 && minli==0)
     {    v1_deriv = (float *) tst_alloc (var_order,sizeof(float),"distrib");
	  v2_deriv = (float *) tst_alloc (var_order,sizeof(float),"distrib");
	  p1_deriv = (int *) tst_alloc (var_order,sizeof(int),"distrib");
	  p2_deriv = (int *) tst_alloc (var_order,sizeof(int),"distrib");
	  calc_deriv = 1;
	  }
	  else calc_deriv = 0;
     jp=1;
     var_init(l_radial->distrib);
     v1 = var_valeur (0);
     v2 = var_valeur (1);
     if (calc_deriv!=0) VAR_io_id
     {   iod = var_io*var_dim+var_id;
         if ( (p1_deriv[iod] = var_param(0))!=0 )
		  v1_deriv[iod] = var_derive ();
	 if ( (p2_deriv[iod] = var_param(1))!=0 )
		  v2_deriv[iod] = var_derive ();
	 }
     aa = angle (*pos);
     na = angle(*(pos+1));
     hh = na - aa;
     v = (v2-v1);
     for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
     {   
         if ( ip % 50 == 0 ) fprintf(list_fich , "amo0 %d  aa %f na %f\n",
      ip, aa, na);     
         if ( *l_points <= aa ) continue;   /* pas d'extrapolation */
/*	 if ( jp > nb_pos)   break;
	 if ( *l_points >= na )
	 {   /* on prepare la table */
/*             v1 = v2;
	     pos++;
             aa = na;
	     var_init(l_radial->distrib);
	     if (calc_deriv!=0) VAR_io_id
	     {   VAR_iod;
	         p1_deriv[iod] = p2_deriv[iod];
		 v1_deriv[iod] = v2_deriv[iod];
		 }
	     if ( ++jp < nb_pos)
	     {   na = angle (*(pos+1));
		 v2 = var_valeur (jp);
		 if (calc_deriv!=0) VAR_io_id
		 {   VAR_iod;
		     if ((p2_deriv[iod] = var_param  (jp))!=0)
		      v2_deriv[iod] = var_derive ();
		      }
		 hh = na - aa;
		 v = (v2-v1);
		 }
	     ip--; l_points--;
	     }
	 else
	 {    ini_amplitude ( *l_points);
              hd = (*l_points - aa) / hh;
				  val = ampli * (v1 + v * hd);
	      add_ical (ip, val);
if ( ip % 50 == 0 ) fprintf(list_fich , " amo %d  %f = %f *( %f + %f * %f)\n",
      ip, val, ampli, v1, v, hd);     
	      if (calc_deriv!=0)
	      {   /* la distribution */
/*		  var_init(l_radial->distrib);
		  VAR_io_id
		  {   VAR_iod;
		      if (p1_deriv[iod])
			add_dydp(ampli * (1-hd) * v1_deriv[iod],ip,p1_deriv[iod]);
		      if (p2_deriv[iod])
			add_dydp(ampli * hd * v2_deriv[iod],ip,p2_deriv[iod]);
		      }
		  /* onde */
/*		 temp = &temp_exper;
		  var_init(l_onde);
		  VAR_io_id
		  for (i=act->lambda*LAMBDA;i<act->lambda*LAMBDA+LAMBDA;i++)
		  if ((j=var_param(i))!=0)
		  {  switch (i%LAMBDA)
		     {
		       case 1 : z = val / exper_echelle;               break;
			   };
		       add_dydp(z * var_derive(), ip,j);
		       }
		 temp = &temp_phase;
		 /* phase scale , overall B non utilise */
/*		 var_init(l_phase->ech);
		 VAR_io_id  for (i=0;i<1;i++)
		 if ((j=var_param(i))!=0)
		  add_dydp (val * var_derive() * *(d_echelle+i),ip,j);
		 /* phase transition scale */
/*		 var_init(l_phase->transit);
		 VAR_io_id  for (i=0;i<var_number;i++)
		 if ((j=var_param(i))!=0)
		       add_dydp(val * var_derive()* *(d_echelle+l_phase->ech->number+i), ip,j);
		 }
	    }
	}
     if (calc_deriv!=0)
     {   free (v1_deriv);
	 free (v2_deriv);
	 free (p1_deriv);
	 free (p2_deriv);
	 }
    }
 /* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */

