static char *cvs_id =" $Id: xnd_r11.c,v 1.2 2002/01/10 15:24:43 berar Exp $ ";
/* XND_R11.C    read 1.1 headers */

#define USE_VAR
#define USE_KEYS

#include "../xnd_def.h"
#include "xnd_rdh.h"
/* ------------------------------------------------------------------ */
/* mode d'ouverture des fichiers */
#ifdef MSDOS
#define R_MODE  "rb"
#define W_MODE  "w+b"
#else
#define R_MODE  "r"
#define W_MODE  "w+"
#endif
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static void get_init_param( P_(void *)par, P_(int)itype, 
                  P_(char *)name, P_(char *) pform, P_(char) apend )
#ifdef NO_PROTO
void * par;
int itype;
char *name;
char *pform;
char apend;
#endif
{   char buffer[102];
    int  n, size;
    char *c, *d;
    int  *ival;
    float *fval;
    char  *sval;
    int irem = lect->rem_nb++;
  push_err_msg("get_init_param");
    c = buffer;
    d = c + 1;
    size = 0;
    purge_cr();
    *c = 0;
    while ( fscanf(coord_fich, " %[#]", c) == 1  )
    {   if (feof(coord_fich)) break;
        fgets( d, 100, coord_fich);
        if ( lect->rem0[irem] )
        {   size += 2+strlen(buffer)+strlen(lect->rem0[irem]);
            lect->rem0[irem] = (char *) realloc(lect->rem0[irem], size);
            strcat(lect->rem0[irem], c);
            }
        else
        {   size += 2+strlen(buffer);
            lect->rem0[irem] = (char *) malloc(size);
            strcpy(lect->rem0[irem], c);
            }
        fputs(c, list_fich);
        purge_cr();
        *c=0;
        }
    switch (itype )
    { case KEYTYPE_INT :  ival = par;
                       n = fscanf(coord_fich, "%d", ival );
                   fprintf (list_fich, pform, name, *ival );
                       break;
      case KEYTYPE_FLOAT : fval = par;
                       n = fscanf(coord_fich, "%f", fval );
                   fprintf (list_fich, pform, name, *fval );
                       break;
      case KEYTYPE_STRING : sval = par;
                       n = fscanf(coord_fich, " %[^ #\n\r\t]", sval );
                   fprintf (list_fich, pform, name, sval );
                       break;
      default : termine(16, "Unvalid type in get_init_param, please report!");
      }            
     tst_abort ((n==0), "Unable to read initial parameter '%s' (type %d)", name, itype);
     while ( fscanf(coord_fich, "%[ ]", c) );
     if ( fscanf(coord_fich, "%[#]", c++) )
     {    fgets( c, 100, coord_fich);
          size = 2+strlen(buffer);
          lect->rem1[irem]=(char *)malloc( size );
          strcpy(lect->rem1[irem], buffer);
          }
     if (lect->rem1[irem])  fputs(lect->rem1[irem], list_fich);
     else if ( apend ) fprintf (list_fich, "%c", apend);

	 pop_err_msg();
	  }
/* ------------------------------------------------------------------ */
static void new_init_param( P_(void *)par, P_(int)itype, P_(int)irem, P_(char) apend )
#ifdef NO_PROTO
void * par;
int itype;
int irem;
char apend;
#endif
{   
    int  *ival;
    float *fval;
    char *sval;
    if (lect->rem0[irem]) fprintf(new_fich, "%s", lect->rem0[irem]);
    switch (itype )
    { case KEYTYPE_INT :  ival = par;
                       fprintf (new_fich, "%5d", *ival );
                       break;
      case KEYTYPE_FLOAT : fval = par;
                       fprintf (new_fich, "%10.4f", *fval );
                       break;
      case KEYTYPE_STRING : sval = par;
                       fprintf (new_fich, " %s", sval );
                       break;
      default : termine(16, "Unvalid type in new_init_param, please report!");
      }            
    if (lect->rem1[irem]) fprintf(new_fich, "   %s", lect->rem1[irem]);
    else putc (apend, new_fich); 
    }
/* ------------------------------------------------------------------ */
#define INIT_PAR  20
#define TEST_PAR   5
#define OTHER_PAR 15
/* ------------------------------------------------------------------ */
int get_11hdr(P_(void))
{ int  irem;
  char *car;

  fscanf (coord_fich," %[^ \n]",list_name);
  list_fich = freopen ( list_name, "w", list_fich);
  if (list_fich==NULL)
  {  printf (E_FOPEN, "listing", list_name);
     exit (10);
     }
  push_err_msg("get_11hdr(xnd_r11.c)");
  fprintf (list_fich, " %s : %s [%s:%s]\n\n%s\n Reference : %s\n \n  %s\n xnd_1.1x header mode :\n",
     lect->prg_name, xnd_release(), xnd_host(), xnd_kernel(), xnd_ref(), xnd_pub(), titre);
  verbose_printf (" files '%s' --> '%s' :  %s\n", lect->coord_name, list_name, str_time);

  lect->rem_nb=irem=0;
  lect->rem0=(char **) tst_alloc(INIT_PAR+TEST_PAR+OTHER_PAR, sizeof(char*), "rem0");
  lect->rem1=(char **) tst_alloc(INIT_PAR+TEST_PAR+OTHER_PAR, sizeof(char*), "rem1");
  memset(lect->rem0, 0, (INIT_PAR+TEST_PAR+OTHER_PAR)*sizeof(char*));
  memset(lect->rem1, 0, (INIT_PAR+TEST_PAR+OTHER_PAR)*sizeof(char*));
  get_init_param( &max_cycle, KEYTYPE_INT, "Number of cycle(s)", " %s : %d ", '\n');
  if (max_cycle < 0)
  {  test_mode = -max_cycle;
     verbose_printf(" TEST_MODE on : %d\n", test_mode);
     get_init_param( &max_cycle, KEYTYPE_INT, "TEST_MODE max_cycle", " %s : %d ", '\n' );
	  if (test_mode & 0x01)  verbose_printf(" TEST prints out matrix and vectors\n");
	  if (test_mode & 0x02)  verbose_printf(" TEST prints out in pseudo-voigt\n");
	  if (test_mode & 0x04)  verbose_printf(" TEST prints out on convol asym\n");
	  if (test_mode & 0x08)
	  {  verbose_printf(" TEST get asym parameters\n");
        get_init_param( &asym_rmin, KEYTYPE_FLOAT, "TEST_MODE asym_rmin", " %s : %f ", '\n' );
	     get_init_param( &asym_rmax, KEYTYPE_FLOAT, "TEST_MODE asym_rmax", " %s : %f ", '\n' );
	     get_init_param( &asym_resol, KEYTYPE_INT,  "TEST_MODE asym_resol", " %s : %d ", '\n' );
	     get_init_param( &asym_width, KEYTYPE_INT,  "TEST_MODE asym_width", " %s : %d ", '\n' );
	     }
	  if (test_mode & 0x10)
	  {  verbose_printf(" TEST get bragg repart parameter\n");
	     get_init_param( &bragg_repart, KEYTYPE_FLOAT,"TEST_MODE bragg_repart", " %s : %f ", '\n' );
	     }
     } else test_mode = 0;
    get_init_param( &lect->nl_sym, KEYTYPE_INT, "Symetry group(s)", " %s : %d ", ',' );
    get_init_param( &lect->nl_ano, KEYTYPE_INT, "Anomalous diffusion table(s)", " %s : %d ", ',' );
    get_init_param( &lect->nl_dif, KEYTYPE_INT, "Scattering table(s)", " %s : %d ", '\n' );
    get_init_param( &n_exper, KEYTYPE_INT, "Number of experiment(s)", " %s : %d ", ',' );
    get_init_param( &n_phase, KEYTYPE_INT, "Number of phase(s)", " %s : %d ", '\n' );
    get_init_param( &eps_stop, KEYTYPE_FLOAT,"Eps_stop", " %s : %.4f ", ',' );
    get_init_param( &eps_prof, KEYTYPE_FLOAT, "Eps_prof", " %s : %.4f ", ',' );
    get_init_param( &relax, KEYTYPE_FLOAT, "Relaxation coef", " %s : %.4f ", '\n' );
    get_init_param( &mod_lsq, KEYTYPE_INT, "method", " %s : %d ", ',' );
    get_init_param( &lect->back_code, KEYTYPE_INT,"back_ground", " %s : %d ", ',' );
    get_init_param( &voigt_mode, KEYTYPE_INT, "Profile", " %s : %d ", '\n' );

    if (mod_lsq ) fprintf (list_fich,"\n The method code implies : %s, %s, %s, %s\n",
      mod_lsq & 1 ? "min.lin.":" ", mod_lsq & 2 ? "w(y_calc)":" ",
     mod_lsq & 4 ? "correl.":" ", mod_lsq & 8 ? "x_back":" ");
    else fprintf (list_fich,"\n The method code implies defaults\n");
    back_mode = lect->back_code & 0x3;
    unc_mode  = (lect->back_code & 0xC) >> 2;
    switch ( back_mode)
    {  case 0 : car = "interpol"; break;
       case 1 : car = "spline"; break;
       case 2 : car = "polynomial"; break;
       case 3 : car = "???"; break;
       }
    fprintf (list_fich," The background code implies : %s%s%s\n",
		car,
		(unc_mode&1)!=0?", adding uncoherent":"",
		(unc_mode&2)!=0?", printing uncoherent":"");
    fprintf (list_fich," The profile code implies : %svoigt\n\n",
	  voigt_mode==0?"pseudo":"");
    if (relax < 0) { relax =fabs(relax); mod_lsq |=1; }
     
    get_init_param( &max_asym, KEYTYPE_INT,"Asymmetry functions code", " %s : %d ", '\n' );
    init_asym_function();
    
    get_init_param( &lect->max_ordre, KEYTYPE_INT,"Parameters expansion order", " %s : %d ", ',' );
    get_init_param( &valid_ref, KEYTYPE_INT, "valid_ref", " %s : %d ", '\n' );
    get_init_param( &lect->prt_sym, KEYTYPE_INT,  "Print sym", " %s : %d ", ',' );
    get_init_param( &lect->prt_dif, KEYTYPE_INT, "Print dif", " %s : %d ", ',' );
    get_init_param( &prt_cor, KEYTYPE_INT, "Print correl", " %s : %d ", '\n' );

    fprintf(list_fich,"\n");
    get_init_param( &prt_new, KEYTYPE_INT,"NEW file", " %s : %d ", ' ' );
    if (prt_new) 
    {    prt_new ++;
         get_init_param( new_name, KEYTYPE_STRING, "NEW name", " %s : '%s' ", '\n' );
         tst_abort ((strcmp(new_name,lect->coord_name)==0), "NEW file is the same than the coord file");
         }  
    if (test_mode==0) tst_abort ((irem>INIT_PAR),E_CHK,"To much init_param to read, please report");
    
    get_init_param( &prt_hkl, KEYTYPE_INT, "HKL file", " %s : %d ", ' ' );
    if (prt_hkl) get_init_param( hkl_name, KEYTYPE_STRING, "HKL name", " %s : '%s' ", '\n' );
    get_init_param( &prt_plg, KEYTYPE_INT, "PLG file", " %s : %d ", ' ' );
    if (prt_plg) 
    {    get_init_param( plg_name, KEYTYPE_STRING, "PLG name", " %s : '%s' ", '\n' );
         if (prt_plg >1 )
         fprintf(list_fich,"        plg_code implies : %s %s %s\n",
             prt_plg&PLG_NHEADER?"no_header":"",
             prt_plg&PLG_ADDEND?"add_endrecord":"",
             prt_plg&PLG_ADDSEMI?"add_semicolumn":"");
             }
       fprintf(list_fich,"\n");
       if (valid_ref > 1)
       {   lect->valid_reste = abs(prt_new) % valid_ref;
       fprintf (list_fich,"\nvalid_ref non nul ==> affinement restreint :\n\
 1 < code < 10 : (code - 2) modulo %d == %d ==> codes affines %d, %dxx\n",
 valid_ref, lect->valid_reste, 2+lect->valid_reste, 2+lect->valid_reste );
      }

      if (prt_hkl & 6 ) fprintf (list_fich,"\nPrinting non calculated lines : prt_hkl = %d\n",prt_hkl);


      get_init_param( &disk_dydp, KEYTYPE_INT, "disk_dydp", " %s : %d ", ' ' );
      get_init_param( &disk_data, KEYTYPE_INT, "disk_data", " %s : %d ", ' ' );

    strcpy(data_name,"");
    if (disk_data)
      get_init_param( data_name, KEYTYPE_STRING,"data name", " %s : '%s' ", '\n' );

    /* chemin vers fichiers standarts et temporaires */
      get_init_param( &lect->tmp_default, KEYTYPE_INT,"tmp_default", " %s : %d ", ' ' );
     if (lect->tmp_default&1)
          get_init_param( lect->data_path, KEYTYPE_STRING,"data_path", " %s : '%s' ", '\n' );
     if (lect->tmp_default&2)
          get_init_param( lect->tmp_path, KEYTYPE_STRING, "tmp_path", " %s : '%s' ", '\n' );
     else strcpy (lect->tmp_path,"");

    fprintf(list_fich,"\n");
    pop_err_msg();
    return 1;
    }
/* ------------------------------------------------------------------ */
int new_11hdr(P_(void))
{ int  irem = 0;

  new_fich = tst_open ( new_name, "w", "NEW file");
  fprintf (new_fich,"%s\n%s\n", titre, list_name);
  if (test_mode == 0) new_init_param( &max_cycle, KEYTYPE_INT, irem++, '\n');
  else
  {  int j = -test_mode;
     new_init_param( &j, KEYTYPE_INT, irem++, '\n');
     new_init_param( &max_cycle, KEYTYPE_INT, irem++, '\n');
     if (test_mode & 0x08)
     {  new_init_param( &asym_rmin, KEYTYPE_FLOAT, irem++, ' ');
	     new_init_param( &asym_rmax, KEYTYPE_FLOAT, irem++, ' ');
	     new_init_param( &asym_resol, KEYTYPE_INT, irem++, ' ');
	     new_init_param( &asym_width, KEYTYPE_INT, irem++, '\n');
	     }
     if (test_mode & 0x10) new_init_param( &bragg_repart, KEYTYPE_FLOAT, irem++, '\n');
     }
  new_init_param( &lect->nl_sym, KEYTYPE_INT, irem++, ' ');
  new_init_param( &lect->nl_ano, KEYTYPE_INT, irem++, ' ');
  new_init_param( &lect->nl_dif, KEYTYPE_INT, irem++, '\n');
  new_init_param( &n_exper, KEYTYPE_INT, irem++, ' ');
  new_init_param( &n_phase, KEYTYPE_INT, irem++, '\n');
  new_init_param( &eps_stop, KEYTYPE_FLOAT, irem++, ' ');
  new_init_param( &eps_prof, KEYTYPE_FLOAT, irem++, ' ');
  new_init_param( &relax, KEYTYPE_FLOAT, irem++, '\n');
  new_init_param( &mod_lsq, KEYTYPE_INT, irem++, ' ');
  new_init_param( &lect->back_code, KEYTYPE_INT, irem++, '\n');
  new_init_param( &voigt_mode, KEYTYPE_INT, irem++, '\n');
  if (asym_mode == 0) new_init_param( &asym_mode, KEYTYPE_INT, irem++, '\n');
  else new_init_param( &max_asym, KEYTYPE_INT, irem++, '\n');
  new_init_param( &lect->max_ordre, KEYTYPE_INT, irem++, ' ');
  new_init_param( &valid_ref, KEYTYPE_INT, irem++, '\n');
  new_init_param( &lect->prt_sym, KEYTYPE_INT, irem++, ' ');
  new_init_param( &lect->prt_dif, KEYTYPE_INT, irem++, ' ');
  new_init_param( &prt_cor, KEYTYPE_INT, irem++, '\n');
  new_init_param( &prt_new, KEYTYPE_INT, irem++, ' ');
  new_init_param( new_name, KEYTYPE_STRING, irem++, '\n');
  new_init_param( &prt_hkl, KEYTYPE_INT, irem++, ' ');
  if (prt_hkl) new_init_param( hkl_name, KEYTYPE_STRING, irem++, '\n');
  new_init_param( &prt_plg, KEYTYPE_INT, irem++, ' ');
  if (prt_plg) new_init_param( plg_name, KEYTYPE_STRING, irem++, '\n');
  fprintf(new_fich,"\n");
  new_init_param( &disk_dydp, KEYTYPE_INT, irem++, ' ');
  new_init_param( &disk_data, KEYTYPE_INT, irem++, ' ');
  if (disk_data) new_init_param( data_name, KEYTYPE_STRING, irem++, '\n');
  new_init_param( &lect->tmp_default, KEYTYPE_INT, irem++, ' ');
  if (lect->tmp_default&1) new_init_param( lect->data_path, KEYTYPE_STRING, irem++, '\n');
  if (lect->tmp_default&2) new_init_param( lect->tmp_path, KEYTYPE_STRING, irem++, '\n');
  fprintf(new_fich,"\n");
  pop_err_msg();
  return 1;
  }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

